package pl.slawas.scjdbc4jpa.config;

import java.io.Serializable;

import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlType;

import pl.slawas.scjdbc4jpa.jdbc.cache.CacheUsage;

@XmlRootElement(name = "entity")
@XmlType(propOrder = { "entityName", "cacheUsage", "cacheRegionName",
		"queryCacheUsage" })
public class JdbcConfigEntityMetadata implements Serializable {

	private static final long serialVersionUID = 1L;

	@XmlElement(name = "entity-name")
	private String entityName;

	@XmlElement(name = "cache-usage")
	private CacheUsage cacheUsage;

	@XmlElement(name = "cache-region-name")
	private String cacheRegionName;

	@XmlElement(name = "query-cache-usage")
	private CacheUsage queryCacheUsage;

	public JdbcConfigEntityMetadata() {
	}

	/**
	 * 
	 * @param entityName
	 * @param cacheUsage
	 * @param cacheRegionName
	 * @param queryCacheUsage
	 */
	public JdbcConfigEntityMetadata(String entityName, CacheUsage cacheUsage,
			String cacheRegionName, CacheUsage queryCacheUsage) {
		super();
		this.entityName = entityName;
		this.cacheRegionName = cacheRegionName;
		this.cacheUsage = cacheUsage;
		this.queryCacheUsage = queryCacheUsage;
	}

	/**
	 * @return the entityName
	 */
	public String getEntityName() {
		return entityName;
	}

	/**
	 * @return the cacheRegionName
	 */
	public String getCacheRegionName() {
		return cacheRegionName;
	}

	/**
	 * @return the cacheUsage
	 */
	public CacheUsage getCacheUsage() {
		return cacheUsage;
	}

	/**
	 * @return the queryCacheUsage
	 */
	public CacheUsage getQueryCacheUsage() {
		return queryCacheUsage;
	}

}
