package pl.slawas.scjdbc4jpa.config;

/**
 * 
 * JpaProperties - klasa z nazwami właściwości czytanymi z pliku
 * konfiguracyjnego.
 * 
 * @author Sławomir Cichy &lt;slawas@slawas.pl&gt;
 * @version $Revision: 1.1 $
 * 
 */
public class JpaProperties {

	/**
	 * Nazwa właściwości definiująca położenie pliku z konfiguracje kesz-a.
	 */
	public static String CACHE_CONFIG_PATH = "jpa.cache.config.path";

	/**
	 * Nazwa właściwości definiująca nazwę używanego providera keszowania
	 */
	public static String CACHE_PROVIDER = "jpa.cache.provider";

	/**
	 * Suffix dla właściwości określających czas życia elementów w keszu
	 */
	public static String CACHE_TIME_TO_LIVE_SUFFIX = "timeToLiveSeconds";

	/**
	 * Nazwa właściwości określająca domyślny czas życia elementów w keszu
	 */
	public static String CACHE_TIME_TO_LIVE = "jpa.cache."
			+ CACHE_TIME_TO_LIVE_SUFFIX;

	/**
	 * Nazwa parametru decydującego o tym, czy podczas używania kesz-a, ma
	 * zostać użyty jeden domyślny region. Region ten nazywa się
	 * 'jdbc.ResultRowMapper' ({@link #CACHE_DEFAULT_REGION_NAME})
	 * Parametr przyjmuje jedną z wartości: {@code true} albo {@code false}.
	 * Jeżeli jest ustawiony na {@code false}, albo nie jest zdefiniowany, to
	 * wtedy będą tworzone osobne regiony o nazwie klasy encji.
	 */
	public static String CACHE_USE_DEFAULT_REGION = "jpa.cache.useDefaultRegion";

	/**
	 * Domyślna nazwa regionu kesza
	 */
	public static String CACHE_DEFAULT_REGION_NAME = "jdbc.ResultRowMapper";

	/**
	 * Nazwa właściwości określająca maksymalną liczbę stron, a tym samym liczbe
	 * wierszy ({@link JpaProperties#JDBC_RESULT_MAX_PAGES} razy zdefiniowany
	 * rozmiar strony np. {@link JdbcConfig#DEFAULT_PAGE_SIZE}) jaka może być
	 * zwrócona przez zapytanie JDBC.
	 */
	public static String JDBC_RESULT_MAX_PAGES = "jdbc.resultMaxPages";

}
