package pl.slawas.scjdbc4jpa.core;

import pl.slawas.scjdbc4jpa.jdbc.types.SimpleSQLType;

public interface ScDefaults {

	public static final String DEFAULT_PERSISTENCE_XML_URL_LOCATION = "classpath*:META-INF/";

	public static final String DEFAULT_PERSISTENCE_XML_DIR_LOCATION = "/META-INF/";

	public static final String OracleDialect = "pl.slawas.jpa.dialect.OracleDialect";

	public static final String DefaultDialect = "pl.slawas.jpa.dialect.DefaultDialect";

	public static final String DetaultJndiName = "java:OraPollDS";

	public static final int DefaultBatchCommitSize = 15;

	public static final int DefaultBatchSize = DefaultBatchCommitSize;

	public static final String TRUE = "TRUE";

	public static final String FALSE = "FALSE";

	/**
	 * "I" - Typ operacji wstawiania/dodawania encji/wiersza
	 */
	final public static String INSERT_DML_TYPE = "I";

	/**
	 * "U" - Typ operacji aktualizacji encji/wiersza
	 */
	final public static String UPDATE_DML_TYPE = "U";

	/**
	 * "D" - Typ operacji usuwania encji/wiersza
	 */
	final public static String DELETE_DML_TYPE = "D";

	/**
	 * Lista typow, ktore sa nielegalne w uzyciu podczas realizacji zwiazku
	 * wiele do jednego (np. dziecko -> rodzic). Dla pol z adnotacja
	 * "ManyToOne".
	 */
	final public static String[] ILLEGAL_TYPES = { "SET" // java.util.Set<?>
			, "LIST" // java.util.List<?>
			, "VECTOR" // java.util.Vector<?>
	};

	/**
	 * "TS" - Typ prosty
	 */
	final public static String TYPE_SIMPLE = "TS";

	/**
	 * jndiDSCtxName "TF" - Typ zlozony, obcy
	 */
	final public static String TYPE_FOREIGN = "TF";

	/**
	 * Lista typow uznawanych przez AresDAOSupport za typy proste
	 */
	final public static String[] SIMPLE_TYPES = {
			SimpleSQLType.STRING.toString() // java.lang.String
			, SimpleSQLType.INTEGER.toString() // java.lang.Integer
			, SimpleSQLType.INT.toString() // int
			, SimpleSQLType.LONG.toString() // java.lang.Long or long
			, SimpleSQLType.SHORT.toString() // java.lang.Short or short
			, SimpleSQLType.FLOAT.toString() // java.lang.Float or float
			, SimpleSQLType.BIGDECIMAL.toString() // java.lang.BigDecimal
			, SimpleSQLType.BYTE.toString() // java.lang.Byte or byte
			, SimpleSQLType.BOOLEAN.toString() // java.lang.Boolean or boolean
			, SimpleSQLType.DATE.toString() // java.util.Date or java.sql.Date
			, SimpleSQLType.CALENDAR.toString() // java.util.Calendar
			, SimpleSQLType.CLOB.toString() // java.sql.Clob
			, SimpleSQLType.NCLOB.toString() // java.sql.NClob
			, SimpleSQLType.BLOB.toString() // java.sql.Blob
			, SimpleSQLType.TIME.toString() // java.sql.Time
			, SimpleSQLType.TIMESTAMP.toString() // java.sql.Timestamp
	};

}