package pl.slawas.scjdbc4jpa.core;

import java.sql.Connection;
import java.sql.SQLException;

import javax.persistence.EntityManager;

import org.hibernate.cfg.Configuration;
import org.hibernate.engine.Mapping;

import pl.slawas.scjdbc4jpa.jpa.mapping.Table;

public interface ScEntityManager extends EntityManager {

	public void setTable(Table table);

	/**
	 * @return the jpaEntityManager
	 */
	public abstract EntityManager getJpaEntityManager();

	public boolean isAllowedConfiguration();

	public boolean isAllowedMapping();

	/**
	 * @return the batchCommitSize
	 */
	public abstract int getBatchCommitSize();

	/**
	 * @return the batchSize
	 */
	public abstract int getBatchSize();

	/**
	 * @return the currentConnection
	 * @throws SQLException
	 */
	public abstract Connection getConnection() throws SQLException;

	/**
	 * @return the hibernate3 configuration
	 */
	public abstract Configuration getConfiguration();

	/**
	 * 
	 * @return
	 */
	public abstract Mapping getMapping();

	public abstract void release();

}
