package pl.slawas.scjdbc4jpa.core;

import javax.persistence.EntityManagerFactory;

import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Required;
import org.springframework.orm.jpa.EntityManagerFactoryInfo;

import pl.slawas.scjdbc4jpa.dialect.DefaultDialect;
import pl.slawas.scjdbc4jpa.jpa._JpaEntityManagerFactory;

public class ScObjectFactoryBean implements ScDefaults, ScObjectFactory {

	final protected Logger log = Logger.getLogger(getClass());

	private EntityManagerFactory emf;

	@Required
	public void setEntityManagerFactory(EntityManagerFactory emf) {
		this.emf = emf;
	}

	public ScEntityManager getEntityManager() {

		ScEntityManager aem;
		if (emf instanceof _JpaEntityManagerFactory) {
			_JpaEntityManagerFactory objectFactory = (_JpaEntityManagerFactory) emf;
			aem = (ScEntityManager) objectFactory.createEntityManager();
			if (log.isDebugEnabled()) {
				StringBuffer getInfo = new StringBuffer(
						"\n********\n Pobieram ScEntityManager");
				getInfo.append("\n	Klasa obiektu: " + aem.getClass().getName());
				getInfo.append("\n	BatchCommitSize: "
						+ objectFactory.getBatchCommitSize());
				getInfo.append("\n	BatchSize: " + objectFactory.getBatchSize());
				getInfo.append("\n********\n");
				log.debug(getInfo.toString());
			}
		} else if (emf instanceof EntityManagerFactoryInfo) {
			EntityManagerFactoryInfo objectFactory = (EntityManagerFactoryInfo) emf;
			aem = new DefaultDialect(objectFactory
					.getNativeEntityManagerFactory().createEntityManager(),
					DefaultBatchSize, DefaultBatchCommitSize, null, null, null);

		} else {
			aem = new DefaultDialect(emf.createEntityManager(),
					DefaultBatchSize, DefaultBatchCommitSize, null, null, null);

		}

		return aem;
	}

	public EntityManagerFactory getEntityManagerFactory() {
		return emf;
	}

}
