package pl.slawas.scjdbc4jpa.dialect;

/**
 * 
 * Dialect - dialekty SQL
 * 
 * @author Sławomir Cichy &lt;slawas@slawas.pl&gt;
 * @version $Revision: 1.1 $
 * 
 */
public enum Dialect {

	/**
	 * Serwery baz danych Oracle
	 */
	ORACLE,
	/**
	 * Serwery baz danych MySQL
	 */
	MYSQL,
	/**
	 * Serwery baz danych PostrgeSQL
	 */
	POSTGRESQL,
	/**
	 * Baza danych HyperSQL Database Engine (HSQLDB)
	 */
	HSQL,
	/**
	 * Domyślny dialekt
	 */
	DEFAULT;

	public Class<?> getEmClass() {

		switch (this) {
		case ORACLE:
			return OracleDialect.class;
		case MYSQL:
			return MySQLDialect.class;
		case POSTGRESQL:
			return PostgreSQLDialect.class;
		case HSQL:
			return HyperSQLDialect.class;
		case DEFAULT:
		default:
			return DialectSupport.class;
		}
	}

	public static Dialect getDialect(Class<?> emClass) {
		if (emClass.getAnnotation(DialectAnnotation.class) != null) {
			return emClass.getAnnotation(DialectAnnotation.class).value();
		}
		return null;
	}
}
