package pl.slawas.scjdbc4jpa.jdbc;

import java.io.Serializable;
import java.util.Vector;

/**
 * 
 * GroupByClause klauzula grupowania wyników zapytania SQL.
 * <p>
 * <font color="#dd0000"><b>Uwaga!</b></font> Klauzula na razie nie wspiera
 * klauzuli {@code HAVING}.
 * </p>
 * 
 * @author Sławomir Cichy &lt;slawas@slawas.pl&gt;
 * @version $Revision: 1.2 $
 * 
 */
public class GroupByClause implements Serializable, _IClause {

	private static final long serialVersionUID = -7307968594304256779L;

	private final Vector<String> groupByFieldList;

	private final String[] groupByFieldArray;

	public GroupByClause(Vector<String> groupConditions) {
		if (groupConditions == null || groupConditions.isEmpty())
			throw new IllegalArgumentException(
					"Lista warunkow grupowania nie moze byc pusta");

		this.groupByFieldList = groupConditions;
		this.groupByFieldArray = new String[this.groupByFieldList.size()];
		int i = 0;
		for (String cond : this.groupByFieldList) {
			this.groupByFieldArray[i] = cond;
			i++;
		}
	}

	public GroupByClause(String[] groupConditions) {
		if (groupConditions == null || groupConditions.length == 0)
			throw new IllegalArgumentException(
					"Lista warunkow grupowania nie moze byc pusta");

		this.groupByFieldArray = groupConditions;
		this.groupByFieldList = new Vector<String>(
				this.groupByFieldArray.length);
		for (String cond : this.groupByFieldArray) {
			this.groupByFieldList.add(cond);
		}
	}

	/**
	 * @return the groupByFieldList
	 */
	public Vector<String> getGroupByFieldList() {
		return groupByFieldList;
	}

	/**
	 * @return the groupByFieldArray
	 */
	public String[] getGroupByFieldArray() {
		return groupByFieldArray;
	}

	public String getClause() {
		StringBuffer out = new StringBuffer("GROUP BY");
		for (int i = 0; i < this.groupByFieldArray.length; i++) {
			out.append((0 == i ? " " : ",") + this.groupByFieldArray[i]);
		}
		return out.toString();
	}

}
