package pl.slawas.scjdbc4jpa.jdbc;

import java.io.Serializable;

class JDBCEntityManagerSequence implements Serializable {

	/**
	 * 
	 */
	private static final long serialVersionUID = -3486379864175139013L;
	/**
	 * sekwencja generowanych instancji {@link JDBCEntityManager} potrzebna do
	 * budowania unikalnych regionów kesza pierwszego poziomu
	 */
	private long entityManagerSequence = 0;

	private JDBCEntityManagerSequence() {
	};

	/**
	 * @return następna wartość sekwencji otwartych managarów encji
	 */
	synchronized long getNextValue() {
		return this.entityManagerSequence++;
	}

	private static JDBCEntityManagerSequence instance;

	/**
	 * @return the {@link #instance}
	 */
	synchronized static JDBCEntityManagerSequence getInstance() {
		if (instance == null) {
			instance = new JDBCEntityManagerSequence();
		}
		return instance;
	}

	@Override
	protected Object clone() throws CloneNotSupportedException {
		throw new CloneNotSupportedException();
	}

}
