package pl.slawas.scjdbc4jpa.jdbc;

/**
 * 
 * ResultType - typ rezultatu, definiujący zachowanie się
 * {@link ResultRowMapper}-a.
 * 
 * 
 * @see ResultRowMapper
 * @see DumpRowMapper
 * @see SelectQuery
 * 
 * @see ResultType#RESTRICTED
 * @see ResultType#UNLIMITED
 * 
 * @author Sławomir Cichy &lt;slawas@slawas.pl&gt;
 * @version $Revision: 1.1 $
 * 
 */
public enum ResultType {

	/**
	 * Wynik przestrzega restrykcji limitu stron
	 * {@link ResultRowMapper#RESULT_MAX_PAGES}.
	 */
	RESTRICTED,
	/**
	 * Wynik nie przestrzega restrykcji limitu stron
	 * {@link ResultRowMapper#RESULT_MAX_PAGES}. Typ wyniku charakterystyczny
	 * dla dump-owania (eksportowania) danych.
	 */
	UNLIMITED;

	public final static Integer UNLIMITED_RESULT_SIZE = Integer.MAX_VALUE;

}
