package pl.slawas.scjdbc4jpa.jdbc;

/**
 * 
 * _IFisrtLevelCacheManager
 * 
 * @author Sławomir Cichy &lt;slawas@slawas.pl&gt;
 * @version $Revision: 1.1 $
 * 
 */
public interface _IFisrtLevelCacheManager {

	/**
	 * Wyłączenie kesza pierwszego poziomu
	 * 
	 * @return {@code true} jeżeli wszystkie kesze podreczne (
	 *         {@link #localQueryCacheManager} oraz {@link #firstLevelCache})
	 *         zostały oznaczone jeko niedostępne.
	 */
	public boolean disableFirstLevelCache();

	/**
	 * Włączenie kesza pierwszego poziomu
	 * 
	 * @return {@code true} jeżeli wszystkie kesze podreczne (
	 *         {@link #localQueryCacheManager} oraz {@link #firstLevelCache})
	 *         zostały oznaczone jeko dostępne.
	 */
	public boolean enableFirstLevelCache();

	/**
	 * Informacja o dostępie do kesz pierwszego poziomu
	 * 
	 * @return {@code true} jeżeli wszystkie kesze podreczne (
	 *         {@link #localQueryCacheManager} oraz {@link #firstLevelCache}) są
	 *         oznaczone jeko dostępne
	 */
	public boolean firstLevelCacheIsAllowed();

}