package pl.slawas.scjdbc4jpa.jdbc.cache.managers;

import pl.slawas.scjdbc4jpa.jdbc.SelectQuery;
import pl.slawas.scjdbc4jpa.jdbc.cache.CacheUsage;

public interface _ICachedQueryInfoManager {

	void addCachedQueryInfo(SelectQuery.QueryCacheInfo queryInfo);

	/**
	 * Usuwanie zapytań z współdzielonego kesza dla obiektu w keszu pierwszego
	 * poziomu, który ma status {@link CacheUsage#REFRESH}
	 */
	void clearCachedQueryInCache();

	/**
	 * Usuwanie zapytań z współdzielonego kesza dla obiektu w keszu pierwszego
	 * poziomu, który ma status {@link CacheUsage#REFRESH} z pominięciem
	 * zapytania, którego identyfikator został podany.
	 * 
	 * @param withoutQueryId
	 *            identyfikator zapytania, które ma nie być ususnięte z
	 *            współdzielonego kesz-a, bo np. właśnie zostało wykonane, i
	 *            obiekt w keszu pierwszego poziomu zostanie na jego podstawie
	 *            odświeżony.
	 */
	void clearCachedQueryInCache(SelectQuery.QueryCacheInfo withoutQueryId);

}