package pl.slawas.scjdbc4jpa.jdbc.dml;

import java.util.Enumeration;
import java.util.Hashtable;
import java.util.Vector;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import pl.slawas.scjdbc4jpa.jdbc.beans.JDBCColumnDesc;
import pl.slawas.scjdbc4jpa.jdbc.beans.JDBCTableDesc;
import pl.slawas.scjdbc4jpa.jdbc.types.SimpleSQLType;
import pl.slawas.scjdbc4jpa.jdbc.where.BindParam;

public class Insert extends DmlQuerySupport {

	final static private Logger logger = LoggerFactory.getLogger(Insert.class);

	private static final long serialVersionUID = 1L;

	public Insert(JDBCTableDesc table) {
		super(table, DataModificationType.INSERT);
	}

	@Override
	protected StringBuffer init() {
		StringBuffer jdbcInsertSQL = new StringBuffer("INSERT INTO ");
		jdbcInsertSQL.append(table.getName() + " (");
		StringBuffer jdbcInsertParams = new StringBuffer();
		this.bindParamsMapper = new Hashtable<String, Vector<BindParam>>();

		Enumeration<String> columns = this.table.getColumnKeys();
		int position = 0;
		while (columns.hasMoreElements()) {
			String entityFieldName = columns.nextElement();
			JDBCColumnDesc column = table.getColumn(entityFieldName);
			logger.trace("Kolumna: {}", column.toString());
			switch (column.getSource()) {
			case MAIN:
				jdbcInsertSQL.append((position == 0 ? "\n  " : "\n ,")
						+ column.getName());
				jdbcInsertParams.append((position == 0 ? "" : ", ") + "?");
				BindParam bindParam = new BindParam(position + 1,
						SimpleSQLType.get(column.getColumnType()), null);
				if (this.bindParamsMapper.containsKey(entityFieldName)) {
					this.bindParamsMapper.get(entityFieldName).add(bindParam);
				} else {
					Vector<BindParam> b = new Vector<BindParam>();
					b.add(bindParam);
					this.bindParamsMapper.put(entityFieldName, b);
				}
				position++;
				break;
			default:
				continue;
			}
		}
		jdbcInsertSQL.append("\n ) VALUES (" + jdbcInsertParams + ")");
		return jdbcInsertSQL;
	}

}
