package pl.slawas.scjdbc4jpa.jdbc.dml;

import java.util.Hashtable;
import java.util.Vector;

import pl.slawas.scjdbc4jpa.jdbc.WhereClause;
import pl.slawas.scjdbc4jpa.jdbc.beans.JDBCTableDesc;
import pl.slawas.scjdbc4jpa.jdbc.where.BindParam;
import pl.slawas.scjdbc4jpa.jdbc.where.ConditionClauseSupport;

public class LockRow extends DmlQuerySupport {

	private static final long serialVersionUID = 1L;

	public LockRow(JDBCTableDesc table) {
		super(table, DataModificationType.SELECT_FOR_UPDATE);
	}

	@Override
	protected StringBuffer init() {
		StringBuffer jdbcLockSQL = new StringBuffer(
				"SELECT 1 AS LOCK_ROW FROM ");
		jdbcLockSQL.append(table.getName());
		this.bindParamsMapper = new Hashtable<String, Vector<BindParam>>();

		WhereClause where = new WhereClause(table.getPrimaryKey());
		jdbcLockSQL.append("\n " + where.getClause() + "\n FOR UPDATE");
		Vector<BindParam> whereParams = where.getBindParams();
		ConditionClauseSupport[] conditionsArray = where.getConditionsArray();
		for (BindParam whereParam : whereParams) {
			int position = whereParam.getParameterIndex();
			String entityFieldName = table.getColumnByDbColumnName(
					conditionsArray[position - 1].getParam().getField())
					.getEntityFieldName();
			if (this.bindParamsMapper.containsKey(entityFieldName)) {
				this.bindParamsMapper.get(entityFieldName).add(whereParam);
			} else {
				Vector<BindParam> b = new Vector<BindParam>();
				b.add(whereParam);
				this.bindParamsMapper.put(entityFieldName, b);
			}
		}

		return jdbcLockSQL;
	}

}
