package pl.slawas.scjdbc4jpa.jdbc.exceptions;

/**
 * 
 * EntityNotJetSavedIdDbException wyjątek związany z tym, że encja jeszcze nie
 * została zapisana do bazy danych, ale już rezyduje w keszu manager-a encji.
 * 
 * @author Sławomir Cichy &lt;slawas@slawas.pl&gt;
 * @version $Revision: 1.1 $
 * 
 */
public class EntityNotJetSavedIdDbException extends RuntimeException {

	private static final long serialVersionUID = 4402962767804201131L;

	/**
	 * 
	 */
	public EntityNotJetSavedIdDbException() {
		super("Encja jeszcze nie została zapisana w bazie danych");
	}

	/**
	 * @param message
	 * @param cause
	 */
	public EntityNotJetSavedIdDbException(String message, Throwable cause) {
		super(message, cause);
	}

	/**
	 * @param message
	 */
	public EntityNotJetSavedIdDbException(String message) {
		super(message);
	}

	/**
	 * @param cause
	 */
	public EntityNotJetSavedIdDbException(Throwable cause) {
		super(cause);
	}

}
