package pl.slawas.scjdbc4jpa.jdbc.sql.functions.oracle;

import pl.slawas.scjdbc4jpa.jdbc.sql.functions.ConcatSupport;

/**
 * 
 * Concat - łączenie stringów - funkcja zaimplementowana dla serwera Oracle
 * 
 * @author Sławomir Cichy &lt;slawas@slawas.pl&gt;
 * @version $Revision: 1.1 $
 * 
 */
public class Concat extends ConcatSupport {

	private static final long serialVersionUID = 8594151083288593623L;

	/**
	 * Konstruktor operatora łączenia łańcuchów znakowych
	 * 
	 * @param alias
	 *            nazwa kolumny w wyniku zapytania SQL pod jaką występować
	 *            bedzie wynik funkcji
	 * @param arguments
	 *            argumenty funkcji
	 */
	public Concat(String alias, String[] arguments) {
		super("CONCAT", alias, arguments);
	}

	@Override
	public String getClause() {
		StringBuffer clause = new StringBuffer();
		clause.append("(");
		int i = 0;
		for (String argument : arguments) {
			clause.append((i != 0 ? " || " : "") + argument);
			i++;
		}
		clause.append(")");
		return clause.toString();
	}
}
