package pl.slawas.scjdbc4jpa.jdbc.types;

import org.apache.log4j.Logger;

import pl.slawas.scjdbc4jpa.core.ScDefaults;

public class SimpleSQLTypeHelper implements ScDefaults {

	/**
	 * Sprawdzenie czy typ o podanej nazwie jest na liscie typow nielegalnych
	 * Uwaga! Wyszukiwanie jest "Case-InSensitive"
	 * 
	 * @param typeName
	 * @return boolean
	 */
	public static boolean isIllegalType(String typeName) {
		for (String type : ILLEGAL_TYPES) {
			if (type.equals(typeName.toUpperCase()))
				return true;
		}
		return false;
	}

	/**
	 * Sprawdzenie czy typ o podanej nazwie jest na liscie typow prostych Uwaga!
	 * Wyszukiwanie jest "Case-InSensitive"
	 * 
	 * @param typeName
	 * @return boolean
	 */
	public static boolean isSimpleType(String typeName) {
		for (String type : SIMPLE_TYPES) {
			if (type.equals(typeName.toUpperCase()))
				return true;
		}
		return false;
	}

	/**
	 * 
	 * @param name
	 * @param value
	 * @param log
	 * @return
	 */
	public static boolean validateBooleanValue(String name, String value,
			Logger log) {
		if (!value.toUpperCase().equals(TRUE)) {
			if (!value.toUpperCase().equals(FALSE)) {
				log.warn("Wrong value of '" + name + "' parameter. "
						+ "To set parameter '" + name
						+ "' use value: 'TRUE' or 'FALSE'. "
						+ "Used default value 'TRUE'.");
				value = TRUE;
				return true;
			}
		}
		return value.toUpperCase().equals(TRUE);
	}

}
