package pl.slawas.scjdbc4jpa.jdbc.where;

import java.io.Serializable;

import pl.slawas.scjdbc4jpa.jdbc.types.SimpleSQLType;

public class BindParam implements Serializable {

	private static final long serialVersionUID = -4828090221285329361L;

	private final int parameterIndex;

	private final SimpleSQLType type;

	private Object paramValue;

	/**
	 * @return the parameterIndex
	 */
	public int getParameterIndex() {
		return parameterIndex;
	}

	/**
	 * @param parameterIndex
	 * @param type
	 * @param paramValue
	 */
	public BindParam(int parameterIndex, SimpleSQLType type, Object paramValue) {
		super();
		this.parameterIndex = parameterIndex;
		this.type = type;
		this.paramValue = paramValue;
	}

	/**
	 * @return the type
	 */
	public SimpleSQLType getType() {
		return type;
	}

	/**
	 * @return the paramValue
	 */
	public Object getParamValue() {
		return paramValue;
	}

	@Override
	public String toString() {
		return "BindParam [ " + parameterIndex + ", " + type + ", "
				+ type.getStringValue(paramValue) + "]";
	}

	/**
	 * @param paramValue
	 *            the paramValue to set
	 */
	public void setParamValue(Object paramValue) {
		this.paramValue = paramValue;
	}

}
