package pl.slawas.scjdbc4jpa.jdbc.where;

import java.io.Serializable;

/**
 * 
 * BindParams klasa pomocnicza służąca do przemieszczania list parametrów
 * bindowanych na potrzeby zmiany wartości parametrów.
 * 
 * @author Sławomir Cichy &lt;slawas@slawas.pl&gt;
 * @version $Revision: 1.1 $
 * 
 */
public class BindParams implements Serializable {

	private static final long serialVersionUID = -8811148023156230935L;

	private final int lastParameterIndexValue;

	private final BindParam[] bindParams;

	/**
	 * @param lastParameterIndexValue
	 * @param bindParams
	 */
	public BindParams(int lastParameterIndexValue, BindParam[] bindParams) {
		super();
		this.lastParameterIndexValue = lastParameterIndexValue;
		this.bindParams = bindParams;
	}

	/**
	 * @return ostatnia wartosc indeksu parametrów
	 */
	public int getLastParameterIndexValue() {
		return lastParameterIndexValue;
	}

	/**
	 * @return the bindParams
	 */
	public BindParam[] getBindParams() {
		return bindParams;
	}

}
