package pl.slawas.scjdbc4jpa.jdbc.where;

/**
 * 
 * ConditionOperator operator logiczny łączący warunki zapytania SQL
 * 
 * @see #AND
 * @see #OR
 * @see #ANDNOT
 * @see #ORNOT
 * 
 * @author Sławomir Cichy &lt;slawas@slawas.pl&gt;
 * @version $Revision: 1.1 $
 * 
 */
public enum ConditionOperator {

	/** operator logiczny "lub" */
	OR("OR"),
	/** operator logiczny "i" */
	AND("AND"),
	/** połączenie operatora logicznego "i" i "nie", co buduje zdanie "i nie" */
	ANDNOT("AND NOT"),
	/**
	 * połączenie operatora logicznego "lub" i "nie", co buduje zdanie "lub nie"
	 */
	ORNOT("OR NOT");

	private final String operator;

	private ConditionOperator(String operator) {
		this.operator = operator;
	}

	/**
	 * @return the operator
	 */
	public String getOperator() {
		return operator;
	}

}
