package pl.slawas.scjdbc4jpa.jdbc.where;

/**
 * 
 * ConditionType typ warunku w klauzuli 'WHERE' zapytania
 * 
 * @author Sławomir Cichy &lt;slawas@slawas.pl&gt;
 * @version $Revision: 1.1 $
 * 
 */
public enum ConditionType {

	/**
	 * warunek zapytania z obsługą wartości NULL
	 */
	NULL,
	/**
	 * obsługa prostych operatorów porównania
	 */
	SIMPLE,
	/**
	 * obsługa prostych operatorów porównania z kryterium jako argument w
	 * funkcji (wynik funkcji jest wartością kryterium)
	 */
	SIMPLEfx,
	/**
	 * obsłga klauzuli LIKE
	 */
	LIKE,
	/**
	 * obsłga klauzuli IN (warunek wieloargumentowy, jednowymiarowa macierz)
	 */
	IN,
	/**
	 * obsłga warunków przedziałowych, z górną i dolną granicą
	 */
	RANGE,
	/**
	 * obsłga warunków przedziałowych, z górną i dolną granicą, z kryteriami
	 * jako argumenty w funkcjach (wynik funkcji jest wartością kryterium)
	 */
	RANGEfx,
	/**
	 * obsługa warunków złozonych (w skład wrunku wchodzą wszystkie pozostałe
	 * typy warunków).
	 */
	BOOL;

}
