package pl.slawas.scjdbc4jpa.jdbc.where;

/**
 * 
 * ParamOperatorRange - proste operatory logiczne dla paramerów z uzyciem
 * przedziałów
 * 
 * @see #BETWEEN
 * @see #SIMPLE
 * 
 * @author Sławomir Cichy &lt;slawas@slawas.pl&gt;
 * @version $Revision: 1.1 $
 * 
 */
public enum ParamOperatorRange implements _IParamOperator {

	/**
	 * Wykorzystanie funkcji "pomiędzy"
	 * <p>
	 * (some-value >= expr_1 and some-value <= expr_2)
	 * </p>
	 */
	BETWEEN("BETWEEN", "NOT BETWEEN"),
	/**
	 * Wykorzystanie operatorów prostych {@link ParamOperatorSimple} do
	 * budowania zakresów wyszukiwania.
	 */
	SIMPLE("", "NOT");

	private final String operator;

	private final String notOperator;

	/**
	 * 
	 * @param operator
	 *            operator
	 * @param notOperator
	 *            operator negatywny
	 */
	private ParamOperatorRange(String operator, String notOperator) {
		this.operator = operator;
		this.notOperator = notOperator;
	}

	public String getOperator() {
		return operator;
	}

	public String getNotOperator() {
		return notOperator;
	}

}
