package pl.slawas.scjdbc4jpa.jdbc.where;

/**
 * 
 * ParamOperatorSimple - proste operatory logiczne dla paramerów warunku
 * zapytania
 * 
 * @see #GT
 * @see #LT
 * @see #EQ
 * @see #GEQ
 * @see #LEQ
 * 
 * 
 * @author Sławomir Cichy &lt;slawas@slawas.pl&gt;
 * @version $Revision: 1.1 $
 * 
 */
public enum ParamOperatorSimple implements _IParamOperator {

	/**
	 * większy '>'
	 */
	GT(">", "<="),
	/**
	 * mniejszy '&lt;'
	 */
	LT("<", ">="),
	/**
	 * równy '='
	 */
	EQ("=", "!="),
	/**
	 * większa/równa '>='
	 */
	GEQ(">=", "<"),
	/**
	 * mniejsza/równa '<='
	 */
	LEQ("<=", ">");

	private final String operator;

	private final String notOperator;

	/**
	 * 
	 * @param operator
	 *            operator
	 * @param notOperator
	 *            operator negatywny
	 */
	private ParamOperatorSimple(String operator, String notOperator) {
		this.operator = operator;
		this.notOperator = notOperator;
	}

	public String getOperator() {
		return operator;
	}

	public String getNotOperator() {
		return notOperator;
	}

}
