package pl.slawas.scjdbc4jpa.jpa.mapping;

import java.io.Serializable;
import java.sql.SQLException;

import org.hibernate.impl.SessionImpl;
import org.hibernate.type.AnyType;
import org.hibernate.type.CollectionType;
import org.hibernate.type.ComponentType;
import org.hibernate.type.EntityType;
import org.hibernate.type.Type;

import pl.slawas.scjdbc4jpa.jpa.dao._IJpaDAO;

/**
 * 
 * Column - definicja kolumny
 * 
 * @author Sławomir Cichy &lt;slawas@slawas.pl&gt;
 * @version $Revision: 1.1 $
 * 
 */
public class Column implements Serializable {

	private static final long serialVersionUID = -4849786268148763110L;

	// TODO powinienem zaimplementowac pozostale metody
	// zwiazane z kolumnami takie jak np.:
	// isNullable, hesCheckConstraint

	private String name;

	private String sqlType;

	private String alias;

	private String propertyName;

	private int position;

	private Type type;

	private boolean componentType = false;

	private boolean anyType = false;

	private boolean associationType = false;

	private boolean collectionType = false;

	private boolean entityType = false;

	private boolean primaryKey = false;

	private String primaryKeyName;

	private boolean foreignKey = false;

	private String foreignKeyName;

	private int keyPosition;

	private int columnLength;

	Object myValue = null;

	@SuppressWarnings("rawtypes")
	private _IJpaDAO associatedDAO;

	/**
	 * @return the name
	 */
	public String getName() {
		return name;
	}

	/**
	 * @param name
	 *            the name to set
	 */
	public void setName(String name) {
		this.name = name;
	}

	/**
	 * @return the sqlType
	 */
	public String getSqlType() {
		return sqlType;
	}

	/**
	 * @param sqlType
	 *            the sqlType to set
	 */
	public void setSqlType(String sqlType) {
		this.sqlType = sqlType;
	}

	/**
	 * @return the alias
	 */
	public String getAlias() {
		return alias;
	}

	/**
	 * @param alias
	 *            the alias to set
	 */
	public void setAlias(String alias) {
		this.alias = alias;
	}

	/**
	 * @return the propertyName
	 */
	public String getPropertyName() {
		return propertyName;
	}

	/**
	 * @param propertyName
	 *            the propertyName to set
	 */
	public void setPropertyName(String propertyName) {
		this.propertyName = propertyName;
	}

	/**
	 * @return the position
	 */
	public int getPosition() {
		return position;
	}

	/**
	 * @param position
	 *            the position to set
	 */
	public void setPosition(int position) {
		this.position = position;
	}

	/**
	 * @return the type
	 */
	public Type getType() {
		return type;
	}

	/**
	 * @param type
	 *            the type to set
	 */
	public void setType(Type type) {
		this.type = type;
	}

	/**
	 * @return the componentType
	 */
	public boolean isComponentType() {
		return componentType;
	}

	/**
	 * @param componentType
	 *            the componentType to set
	 */
	public void setComponentType(boolean componentType) {
		this.componentType = componentType;
	}

	/**
	 * @return the anyType
	 */
	public boolean isAnyType() {
		return anyType;
	}

	/**
	 * @param anyType
	 *            the anyType to set
	 */
	public void setAnyType(boolean anyType) {
		this.anyType = anyType;
	}

	/**
	 * @return the associationType
	 */
	public boolean isAssociationType() {
		return associationType;
	}

	/**
	 * @param associationType
	 *            the associationType to set
	 */
	public void setAssociationType(boolean associationType) {
		this.associationType = associationType;
	}

	/**
	 * @return the collectionType
	 */
	public boolean isCollectionType() {
		return collectionType;
	}

	/**
	 * @param collectionType
	 *            the collectionType to set
	 */
	public void setCollectionType(boolean collectionType) {
		this.collectionType = collectionType;
	}

	/**
	 * @return the primaryKey
	 */
	public boolean isPrimaryKey() {
		return primaryKey;
	}

	/**
	 * @param primaryKey
	 *            the primaryKey to set
	 */
	public void setPrimaryKey(boolean primaryKey) {
		this.primaryKey = primaryKey;
	}

	/**
	 * @return the primaryKeyName
	 */
	public String getPrimaryKeyName() {
		return primaryKeyName;
	}

	/**
	 * @param primaryKeyName
	 *            the primaryKeyName to set
	 */
	public void setPrimaryKeyName(String primaryKeyName) {
		this.primaryKeyName = primaryKeyName;
	}

	/**
	 * @return the foreignKey
	 */
	public boolean isForeignKey() {
		return foreignKey;
	}

	/**
	 * @param foreignKey
	 *            the foreignKey to set
	 */
	public void setForeignKey(boolean foreignKey) {
		this.foreignKey = foreignKey;
	}

	/**
	 * @return the foreignKeyName
	 */
	public String getForeignKeyName() {
		return foreignKeyName;
	}

	/**
	 * @param foreignKeyName
	 *            the foreignKeyName to set
	 */
	public void setForeignKeyName(String foreignKeyName) {
		this.foreignKeyName = foreignKeyName;
	}

	/**
	 * @return the keyPosition
	 */
	public int getKeyPosition() {
		return keyPosition;
	}

	/**
	 * @param keyPosition
	 *            the keyPosition to set
	 */
	public void setKeyPosition(int keyPosition) {
		this.keyPosition = keyPosition;
	}

	/**
	 * @return the entityType
	 */
	public boolean isEntityType() {
		return entityType;
	}

	/**
	 * @param entityType
	 *            the entityType to set
	 */
	public void setEntityType(boolean entityType) {
		this.entityType = entityType;
	}

	/**
	 * @return the columnLength
	 */
	public int getColumnLength() {
		return columnLength;
	}

	/**
	 * @param columnLength
	 *            the columnLength to set
	 */
	public void setColumnLength(int columnLength) {
		this.columnLength = columnLength;
	}

	@SuppressWarnings("unchecked")
	public void fetchValue(Object value, SessionImpl sessionImpl)
			throws SQLException {

		if (this.componentType) {
			ComponentType com = (ComponentType) this.type;
			myValue = com.getPropertyValue(value, this.keyPosition,
					org.hibernate.EntityMode.POJO);

		} else if (this.anyType) {
			AnyType com = (AnyType) this.type;
			myValue = com
					.getPropertyValue(value, this.keyPosition, sessionImpl);
		} else if (this.associationType) {
			myValue = associatedDAO.fetchValues(value).getIdentifierValues()[this.keyPosition];
		} else if (this.collectionType) {
			// TODO zrobic rozkodowanie wartosci dla collection
			CollectionType com = (CollectionType) this.type;
			myValue = "Collection:"
					+ com.getAssociatedEntityName(sessionImpl.getFactory());
		} else if (this.entityType) {
			// TODO zrobic rozkodowanie wartosci dla entity
			EntityType com = (EntityType) this.type;
			myValue = "Entity:" + com.getAssociatedEntityName();
		} else {
			myValue = value;
		}
	}

	public Object getValue() {
		return myValue;
	}

	/**
	 * @return the associatedDAO
	 */
	@SuppressWarnings("rawtypes")
	public _IJpaDAO getAssociatedDAO() {
		return associatedDAO;
	}

	/**
	 * @param associatedDAO
	 *            the associatedDAO to set
	 */
	@SuppressWarnings("rawtypes")
	public void setAssociatedDAO(_IJpaDAO associatedDAO) {
		this.associatedDAO = associatedDAO;
	}

}
