package pl.slawas.scjdbc4jpa.jpa.mapping;

import java.io.Serializable;

/**
 * 
 * RowValues lista wartości odpowiadająca odpowiednim komumnom
 * 
 * @author Sławomir Cichy &lt;slawas@slawas.pl&gt;
 * @version $Revision: 1.1 $
 * 
 */
public class RowValues implements Serializable {

	private static final long serialVersionUID = 6932776330481786894L;

	private Column[] columnValues;

	private Column[] identifierValues;

	public RowValues(Column[] columnValues, int[] identifierPositions) {
		this.columnValues = columnValues;
		this.identifierValues = new Column[identifierPositions.length];
		int j = 0;
		for (int i : identifierPositions) {
			identifierValues[j] = columnValues[i];
			j++;
		}
	}

	/**
	 * @return the columnValues
	 */
	public Column[] getColumnValues() {
		return columnValues;
	}

	/**
	 * @return the columnValues at identifier position
	 */
	public Column[] getIdentifierValues() {
		return identifierValues;
	}

}
